function LL=meisnerfigfunct_30Jul13(est)

global Y Tsample ib jb mb nb counter tempest ...
	Temp atemp SADdist stageInts mumInts year relatt sexratio L sj totStage timescale Rep ...
	flist

count1=0;
count2=0;

est=full(sparse(ib,jb,est,mb,nb));
tempest=est;

% extract parameters
alist=[est(1)*atemp est(1)*atemp];
s1=est(7);
s2=est(8);
s3=est(9);
rho=2/(1+exp(-est(10)))-1;
mumDetect=est(11);
sw=est(6);
sm=est(12);

dk=[0 est(13)];
dkk=[0 est(14)];
dh=[0 est(15)];

% fixed parameters
%a=ascale*atemp;

Su=0.2015^2*eye(2);

% increased ME for mummies for development time
Su(2,2)=sm*Su(2,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Su(1,1)=.0000001*Su(1,1);
%Su(2,2)=.0000001*Su(2,2);
%Su=.0000001*Su;
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
Yfit=zeros(length(Tsample),2);
% untransfit=zeros(length(Tsample),4);
% fit=zeros(length(Tsample),4);
% 
E=zeros(length(Tsample),2);
% Ehat=zeros(length(Tsample),2);

logFt=0;
vFv=0;

Q=length(Tsample);
T=1;
% vlist=[];

flist=zeros(1,Q);

while T<=Q
	
	% PREDICTION EQUATIONS
	
	% use first point of data rather than fit the first point
	if Tsample(T)==0	
		
		temp=Temp(T)+1;
		
		k=est(2)+dk(temp);
		kp=est(3)*k;
		kk=est(4)+dkk(temp);
		h=abs(est(5))+dh(temp);
		
		nx=totStage;
		ny=sum(mumInts(temp,:))+1;

		x=exp(Y(T,1))*SADdist(:,temp);	
		y=zeros(ny,1);

		% process error for aphids, parasitized aphids, and adult
		% parasitoids
		yy=[x;y];
		nap=nx+mumInts(temp,1);
		
		Se=zeros(nx+ny,nx+ny);
		Se(1:nap,1:nap)=...
			(s1^2+min(.5,1/abs(1+sum(yy(1:nap)))))*(rho*ones(nap,nap)+(1-rho)*eye(nap));
		
		Se(nap+1:end-1,nap+1:end-1)=0;
		
		Se(1:nap,nap+1:end-1)=0;
		Se(nap+1:end-1,1:nap)=0;
		
		Se(end,end)=s3^2+1/abs(1+yy(end));
		
		Yfit(T,:)=log([sum(x) 0]);
		
		PP=Se;
		
		if year(T)==2008
			y=zeros(ny,1);
			a=alist(1:2);
			y(end)=2;
		else
			a=alist(3:4);
		end
		T=T+1;
		t=0;
		
	else
		
		if year(T)==2008
			if t==2/timescale-1 | t==4/timescale-1
				y(end)=2+y(end);
			end
		else
			if t<35/timescale-2
				y=zeros(ny,1);
			end
			if t==35/timescale-2 | t==40/timescale-2
				y(end)=5+y(end);
			end
		end
		
		if year(T)==2008 & Rep(T)==2 & t>56
			y(:)=0;
		end
		
		yp=y(1:mumInts(temp,1));
		yp=yp(find(yp>0));
		sxy=sum([x; yp]);
		K=1/(1+k*sxy);
		Kp=1/(1+kp*sxy);

		sx=relatt(temp,:)*x;
		AA=(1+a(temp)*relatt(temp,:)*y(end)./(kk*(h*sx+1)))';
		A=AA.^(-kk);

		LL=sparse(L(:,:,temp));

		xt=K*A.*(LL*x);

		yt=y;
		yt(end)=sw*y(end) + sexratio*y(end-1);
		yt(mumInts(temp,1)+2:end-1)=y(mumInts(temp,1)+1:end-2);
		yt(2:mumInts(temp,1)+1)=Kp*sj(temp)*y(1:mumInts(temp,1));
		yt(1)=Kp*(ones(totStage,1)-A)'*(LL*x);

		dAa=h*AA.^(-1).*((a(temp)*relatt(temp,:)*y(end))*(h*sx+1)^(-2))';
		dA=dAa*(relatt(temp,:).*x');
		dLL=((1./(LL*x))*x').*LL;
		B11=-k*K*ones(length(x),1)*x' + dA + dLL;
		B11(end,:)=zeros(1,nx);
		
		B12=zeros(length(x),length(y));
		B12(:,1:mumInts(temp(1),1))=-k*K*ones(length(x),1)*y(1:mumInts(temp,1))';
		B12(:,end)=(-1./xt).*Kp.*(AA).^(-kk-1).*((a(temp)*relatt(temp,:)*y(end))/(h*sx+1))'.*(LL*x);
		B12(end,end)=0;

		dKp=-kp*Kp^2*x'*((ones(totStage,1)-A)'*(LL*x));	

		dA1=h*(AA').^(-kk-1).*((a(temp)*relatt(temp,:)*y(end))*(h*sx+1)^(-2))*(LL*x);
		dA2=-dA1*(a(temp)*relatt(temp,:).*x');

		dLL1=((ones(totStage,1)-A)'*LL).*x';

		B21_1=(1/yt(1))*(dKp + Kp*(dA2+dLL1));
		B21_1(find(isnan(B21_1)))=0;
		B21_2=-kp*Kp*ones(mumInts(temp,1),1)*x';
		B21_3=zeros(mumInts(temp,2),length(x));
		B21=[B21_1;B21_2;B21_3];

		B22_1=zeros(1,length(y));
		B22_1(1:mumInts(temp,1))=-kp*Kp*y(1:mumInts(temp,1));
		B22_1(end)=(1/yt(1))*Kp*((AA').^(-kk-1).*((a(temp)*relatt(temp,:)*y(end))/(h*sx+1))*(LL*x));

		B22_2=sparse(zeros(mumInts(temp,1),length(y)));
		dKp1=-kp*Kp*(ones(mumInts(temp,1),1)*y(1:mumInts(temp,1))');
		B22_2(1:mumInts(temp,1),1:mumInts(temp,1))=dKp1+eye(mumInts(temp,1));

		B22_3=sparse(zeros(mumInts(temp,2)-1,length(y)));
		B22_3(:,mumInts(temp,1)+2:length(y)-1)=diag(ones(mumInts(temp,2)-2,1),-1);
		%%%%%%%%%% fixed 5Jul11%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		B22_3(1,mumInts(temp,1)+1)=1;
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		B22_4=sparse(zeros(1,length(y)));
		B22_4(end-1:end)=(1/yt(end))*[sexratio*y(end-1),sw*y(end)];

		B22=[B22_1;B22_2;B22_3;B22_4];

		% check derivatives
		if 0

			tol=10^-6;

			%		B11
			delta=10^-6;
			for i=1:length(x)
				xx=x;
				xx(i)=exp(delta)*xx(i);
				sxy=sum([xx; y(1:mumInts(temp(3),1))]);
				K=1/(1+k*sxy);

				sx=sum(relatt(temp(1),:)*xx);
				AA=(1+a(temp(4))*relatt(temp(1),:)*y(end)./(kk*(h*sx+1)))';
				A=AA.^(-kk);

				xxt=K*A.*(L*xx);
				test=max(abs((B11(:,i)-(log(xxt)-log(xt))/delta)./B11(:,i)));
				if test>tol
					['B11  ',num2str(i)]
					[B11(:,i) (log(xxt)-log(xt))/delta]
				end
			end

			%		B12

			delta=10^-6;
			for i=1:length(y);
				yy=y;
				yy(i)=exp(delta)*yy(i);
				sxy=sum([x; yy(1:mumInts(temp(3),1))]);
				K=1/(1+k*sxy);

				sx=sum(relatt(temp(1),:)*x);
				AA=(1+a(temp(4))*relatt(temp(1),:)*yy(end)./(kk*(h*sx+1)))';
				A=AA.^(-kk);

				xxt=K*A.*(L*x);
				test=max(abs((B12(:,i)-(log(xxt)-log(xt))/delta)./B12(:,i)));
				if test>tol
					['B12  ',num2str(i)]
					[B12(:,i) (log(xxt)-log(xt))/delta]
				end
			end	

			%		B21

			delta=10^-8;
			for i=1:length(x)
				xx=x;
				xx(i)=exp(delta)*xx(i);

				sxy=sum([xx; y(1:mumInts(temp(3),1))]);
				Kp=1/(1+kp*sxy);

				sx=relatt(temp(1),:)*xx;
				AA=(1+a(temp(4))*relatt(temp(1),:)*y(end)./(kk*(h*sx+1)))';
				A=AA.^(-kk);

				yyt=y;
				yyt(end)=sw*y(end) + sexratio*y(end-1);
				yyt(mumInts(temp(3),1)+2:end-1)=y(mumInts(temp(3),1)+1:end-2);
				yyt(2:mumInts(temp(3),1)+1)=Kp*sj(temp(3))*y(1:mumInts(temp(3),1));
				yyt(1)=Kp*(ones(totStage,1)-A)'*(L*xx);

				test=max(abs((B21(:,i)-(log(yyt)-log(yt))/delta)./B21(:,i)));
				if test>tol
					['B21  ',num2str(i)]
					[B21(:,i) (log(yyt)-log(yt))/delta]
				end
			end

			%		B22

			delta=10^-6;
			for i=1:length(y)
				yy=y;
				yy(i)=exp(delta)*yy(i);

				sxy=sum([x; yy(1:mumInts(temp(3),1))]);
				Kp=1/(1+kp*sxy);

				sx=relatt(temp(1),:)*x;
				AA=(1+a(temp(4))*relatt(temp(1),:)*yy(end)./(kk*(h*sx+1)))';
				A=AA.^(-kk);

				yyt=yy;
				yyt(end)=sw*yy(end) + sexratio*yy(end-1);
				yyt(mumInts(temp(3),1)+2:end-1)=yy(mumInts(temp(3),1)+1:end-2);
				yyt(2:mumInts(temp(3),1)+1)=Kp*sj(temp(1))*yy(1:mumInts(temp(3),1));
				yyt(1)=sum(Kp*(ones(totStage,1)-A).*(L*x));

				test=max(abs((B22(:,i)-(log(yyt)-log(yt))/delta)./B22(:,i)));
				if test>tol
					['B22  ',num2str(i)]
					[B22(:,i) (log(yyt)-log(yt))/delta]
				end
			end
		end

%%%%%%%%%%%%%%%%%%%%%%%
		if sum(xt)<.5
			xt=(.5/sum(xt))*xt;
		end
		
		if sum(yt(mumInts(temp,1)+1:end-1))<.5 & sum(yt(mumInts(temp,1)+1:end-1))>0
			yt(mumInts(temp,1)+1:end-1)=(.5/sum(yt(mumInts(temp,1)+1:end-1)))*yt(mumInts(temp,1)+1:end-1);
		end
%%%%%%%%%%%%%%%%%%%%%%%

		B=[B11 B12;B21 B22];

		yy=[x;y];
		ypick=find(yy>0);

		% process error for aphids, parasitized aphids, and adult
		% parasitoids
		yy=[x;y];
		nap=nx+mumInts(temp,1);
		
		Se=zeros(nx+ny,nx+ny);
		Se(1:nap,1:nap)=...
			(s1^2+min(.5,1/abs(1+sum(yy(1:nap)))))*(rho*ones(nap,nap)+(1-rho)*eye(nap));
		
		Se(nap+1:end-1,nap+1:end-1)=0;
		
		Se(1:nap,nap+1:end-1)=0;
		Se(nap+1:end-1,1:nap)=0;
		
		Se(end,end)=s3^2+1/abs(1+yy(end));
		
%		[sum(x) min(.5,1/abs(1+sum(x)))]

		PP(ypick,ypick)=B(ypick,ypick)*PP(ypick,ypick)*B(ypick,ypick)' + Se(ypick,ypick);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% stop instantaneous production of aphids
%  		t
		count1=count1+7;
  		if min(x(1:7)'-xt(2:8)') < 0
%			[x(1:7)';xt(2:8)']
			count2=count2+sum((x(1:7)'-xt(2:8)') < 0);
		end
		
		xt(2:8)=min([x(1:7)';xt(2:8)']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		x=xt;
		y=yt;
		
%		[t max(isnan(x)) max(isnan(x))]
		t=t+1;
	end


	% UPDATING EQUATIONS
	
	if t==Tsample(T)

		yp1=y(1:mumInts(temp,1));
		yp1=yp1(find(yp1>0));
		yp2=y(mumInts(temp,1)+1:end-1);
		yp2=yp2(find(yp2>0));
		
		ypred=log([sum(x)+sum(yp1);sum(yp2)]);
		ypred(2)=ypred(2)+mumDetect;
		
		if sum(yp2)>0

			Z=zeros(2,nx+ny);
			Z(1,1:nx+mumInts(temp,1))=exp(-ypred(1))*[x' y(1:mumInts(temp,1))'];
			Z(2,nx+mumInts(temp,1)+1:end-1)=exp(-ypred(2))*y(mumInts(temp,1)+1:end-1)';

			yy=[x;y];
			ypick=find(yy>0);

			F=Z(:,ypick)*PP(ypick,ypick)*Z(:,ypick)'+Su;

			vv=Y(T,:)'-ypred;	
%			[t temp Y(T,:) ypred']

			invF=F\eye(2);

			ly=yy;
			ly(ypick)=log(yy(ypick));
			ly(ypick)=ly(ypick)+PP(ypick,ypick)*Z(:,ypick)'*invF*vv;
			

			PP(ypick,ypick)=PP(ypick,ypick)-PP(ypick,ypick)*Z(:,ypick)'*invF*Z(:,ypick)*PP(ypick,ypick);

			yy(ypick)=exp(ly(ypick));
			
% 			t
% 			[x(1:7)';yy(2:8)';([x(1:7)'-yy(2:8)'])>0]
			
			x=yy(1:nx);
			y=yy(nx+1:end);
			y(mumInts(temp,1)+1:end-1)=exp(-mumDetect)*y(mumInts(temp,1)+1:end-1);

			yp1=y(1:mumInts(temp,1));
			yp1=yp1(find(yp1>0));
			yp2=y(mumInts(temp,1)+1:end-1);
			yp2=yp2(find(yp2>0));

			Yfit(T,1)=log(sum(x)+sum(yp1));
			Yfit(T,2)=log(sum(yp2))+mumDetect;
			E(T,:)=vv';

		else
			Z=zeros(1,nx+ny);
			Z(1:nx+mumInts(temp,1))=exp(-ypred(1))*[x' y(1:mumInts(temp,1))'];

			yy=[x;y];
			ypick=find(yy>0);

			F=Z(ypick)*PP(ypick,ypick)*Z(ypick)'+Su(1,1);
			vv=Y(T,1)-ypred(1);
%			[t temp Y(T,:) ypred']
			
			invF=1/F;
			ly=yy;
			ly(ypick)=log(yy(ypick));
			
			oldly=ly;
			
			ly(ypick)=ly(ypick)+PP(ypick,ypick)*Z(ypick)'*invF*vv;

			PP(ypick,ypick)=PP(ypick,ypick)-PP(ypick,ypick)*Z(ypick)'*invF*Z(ypick)*PP(ypick,ypick);

			yy(ypick)=exp(ly(ypick));

 			oldx=x;
 			oldy=y;
			x=yy(1:nx);
			y=yy(nx+1:end);

			yp1=y(1:mumInts(temp,1));
			yp1=yp1(find(yp1>0));
			yp2=y(mumInts(temp,1)+1:end-1);
			yp2=yp2(find(yp2>0));

			Yfit(T,1)=log(sum(x)+sum(yp1));
			Yfit(T,2)=log(sum(yp2))+mumDetect;
			E(T,:)=vv';
		end
						
		% TERMS OF LIKELIHOOD FUNCTION
		logdetF=log(det(F));
		logFt=logFt+logdetF;
		
		vvinvFvv=vv'*invF*vv;
		vFv=vFv+vvinvFvv;
		
		flist(T)=logdetF+vvinvFvv;

%		vlist=[vlist; vv'*invF*vv log(det(F)) vv'*vv];

		T=T+1;
	end
end

% figure(200)
% plot(vlist(:,3),vlist(:,1)+vlist(:,2),'.')

LL=logFt+vFv;
counter=counter+1;

if ~isreal(LL) | isnan(LL)
	LL=10^50;
end

%counts=[count1 count2 count2/count1]

% if mod(counter,1)==0
% 	LL
% 	est
% end

if mod(counter-1,500)==0
	[counter LL]
	est
	
	R2=1-var(E)./var(Y)
	
	counts=[count1 count2 count2/count1]

	figure(100)
	clf

	trtcol='br';
	sym='.o';
	outfile=[];
	for i=1:4
		subplot(2,2,1)
		YY=Y(find(Rep==i),:);
		YYfit=Yfit(find(Rep==i),:);
% 		YY=exp(Y(find(Rep==i),:));
% 		YYfit=exp(Yfit(find(Rep==i),:));
		
		temp=Temp(find(Rep==i));
		temp=temp(1)+1;
		plot(timescale*Tsample(find(Rep==i)),YY(:,1),[trtcol(temp),sym(mod(i,2)+1)],...
			timescale*Tsample(find(Rep==i)),YYfit(:,1),[trtcol(temp),'-'])
		ylabel('aphids')
		%axis([0 80 0 1500])
		if i==1
			title(num2str(LL))
		end
		hold on

		subplot(2,2,3)
		plot(timescale*Tsample(find(Rep==i)),YY(:,2),[trtcol(temp),sym(mod(i,2)+1)],...
			timescale*Tsample(find(Rep==i)),YYfit(:,2),[trtcol(temp),'-'])
		ylabel('mummies')
		%axis([0 80 0 150])
		hold on
		
		outfile=[outfile;i*ones(length(YY(:,1)),1) timescale*Tsample(find(Rep==i)) YY(:,1) YYfit(:,1) YY(:,2) YYfit(:,2)];
	end

	for i=5:8
		subplot(2,2,2)
		YY=Y(find(Rep==i),:);
		YYfit=Yfit(find(Rep==i),:);
% 		YY=exp(Y(find(Rep==i),:));
% 		YYfit=exp(Yfit(find(Rep==i),:));

		temp=Temp(find(Rep==i));
		temp=temp(1)+1;
		plot(timescale*Tsample(find(Rep==i)),YY(:,1),[trtcol(temp),sym(mod(i,2)+1)],...
			timescale*Tsample(find(Rep==i)),YYfit(:,1),[trtcol(temp),'-'])
		ylabel('aphids')
		%axis([0 80 0 1500])
		hold on

		subplot(2,2,4)
		plot(timescale*Tsample(find(Rep==i)),YY(:,2),[trtcol(temp),sym(mod(i,2)+1)],...
			timescale*Tsample(find(Rep==i)),YYfit(:,2),[trtcol(temp),'-'])
		ylabel('mummies')
		%axis([0 80 0 150])
		hold on
		
		outfile=[outfile;i*ones(length(YY(:,1)),1) timescale*Tsample(find(Rep==i)) YY(:,1) YYfit(:,1) YY(:,2) YYfit(:,2)];

	end
	hold off
	
	dlmwrite('Meisner Fig3 data 22Aug13', outfile, 'precision', 4)
	
	drawnow
	
	if 0
		figure(101)
		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			for j=1:4
				subplot(2,4,4*(i-1)+j)
				pick=Tsamplestart(j):Tsamplestart(j+1)-1;

				plot(Tsample(pick),e(pick),'g-',Tsample(pick),xx(pick),'k-',Tsample(pick),xobs(pick),'rx');
			end
		end

		figure(102)
		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			for j=1:4
				subplot(2,4,4*(i-1)+j)
				pick=Tsamplestart(j):Tsamplestart(j+1)-1;

				corr=corrcoef(e(pick(2):pick(end)),e(pick(1):pick(end-1)));
				hist(e(pick));
				title(['cor=',num2str(corr(1,2))])
			end
		end

		figure(103)
		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			for j=1:4
				subplot(2,4,4*(i-1)+j)
				pick=Tsamplestart(j):Tsamplestart(j+1)-1;

				plot(Tsample(pick),e(pick),'g-',Tsample(pick),s2e(pick),'b-');
			end
		end

		figure(104)

		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			j=1;
			subplot(2,1,i)
			pick=Tsamplestart(j):Tsamplestart(j+1)-1;

			plot(Time(Tsample(pick)),e(pick),'g-',Time(Tsample(pick)),xx(pick),'k-',Time(Tsample(pick)),xobs(pick),'rx');
		end
	
		figure(105)
		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			j=1;
			subplot(2,1,i)
			pick=Tsamplestart(j):Tsamplestart(j+1)-1;

			plot(Tsample(pick),e(pick),'g-',Tsample(pick),s2e(pick),'b-');
		end
		
		figure(106)
		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			difcum=[];

			for j=1:4
				pick=Tsamplestart(j):Tsamplestart(j+1)-1;
				
				xxdif=xx(pick(2:end))-xx(pick(1:end-1));
				xobsdif=xobs(pick(2:end))-xobs(pick(1:end-1));
				
				difcum=[difcum;xxdif,xobsdif];
			end
			subplot(2,2,2*(i-1)+1)
			hist(difcum(:,2))
			
			subplot(2,2,2*(i-1)+2)
			hist(difcum(:,1))
		end


		figure(200)
		set(200,'position',[306   303   748   506])

		subplot(2,1,1)
		for i=1:2
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			j=1;
			pick=Tsamplestart(j):Tsamplestart(j+1)-1;
			if i==1
				plot(Time(Tsample(pick))/365,xx(pick),'k-',Time(Tsample(pick))/365,xobs(pick),'kx');
				hold on
			else
				plot(Time(Tsample(pick))/365,xx(pick),'r-',Time(Tsample(pick))/365,xobs(pick),'rx');
				hold off
			end
		end
		
		subplot(2,1,2)
		for i=1
			xx=Xfit(:,i);
			xobs=Y(Tsample,i);
			e=E(:,i);
			s2e=s2E(:,i).^.5;

			j=1;
			pick=Tsamplestart(j):Tsamplestart(j+1)-1;
			plot(Time(Tsample(pick))/365,exp(xx(pick)),'k-',Time(Tsample(pick))/365,exp(xobs(pick)),'kx');
			axis([0 12 0 150])

		end

	end
%	drawnow
end
